﻿<#
    .NOTES
    --------------------------------------------------------------------------------
     Generated on:       03/22/2017
     Generated by:       Maurice.Daly
     Adopted by:         Gary.Blok
     PE Support Added by: Mark Godfrey
	 File Name: 		 DellBiosDownloadUpdate.ps1
	 Version:			 1.0
    --------------------------------------------------------------------------------
    .REQUIREMENTS
        This script requires Internet Connection to download Content from Dell
    .DESCRIPTION
        This script allows you to automate the download and update of Dell Bios.
        It will grab the Model from WMI then create the download URL for the Dell Bios
        It will then download the latest Bios to the machine and apply it.
		

		
		Use : This script is provided as it and I accept no responsibility for any issues arising from its use.
 
		Twitter : @modaly_it
		Blog : http://www.scconfigmgr.com
    
        Twitter : @gwblok
        Blog: https://garytown.com

        Twitter : @Geodesicz
        Blog: http://www.tekuits.com
 

		ChangeLog
		
		Version 1.0 - First Release w/ help of Maurice Daly
#>

[CmdletBinding()]
Param(
    [Parameter(Mandatory=$true,Position=1,HelpMessage="BIOS Password")]
    [ValidateNotNullOrEmpty()]
    [string]$BIOSpassword
)


        # =================== DEFINE VARIABLES =====================
		
        $ComputerModel = Get-WmiObject -Class Win32_computersystem | Select-Object -ExpandProperty Model
		
        # Define Dell Download Sources
		$DellDownloadList = "http://downloads.dell.com/published/Pages/index.html"
		$DellDownloadBase = "http://downloads.dell.com"
		$DellSCCMDriverList = "http://en.community.dell.com/techcenter/enterprise-client/w/wiki/2065.dell-command-deploy-driver-packs-for-enterprise-client-os-deployment"
		$DellSCCMBase = "http://en.community.dell.com"
		# ==========================================================
		# =================== INITIATE DOWNLOAD ===================
		# ==========================================================
		
		$Links = (Invoke-WebRequest -Uri $DellDownloadList -UseBasicParsing).Links
        $ModelLink = $Links | where outerHTML -like "*$ComputerModel*"
		$ModelURL = (Split-Path $DellDownloadList -Parent) + "/" + ($ModelLink.href)
			
		# Correct slash direction issues
		$ModelURL = $ModelURL.Replace("\", "/")
		$BIOSDownload = (Invoke-WebRequest -Uri $ModelURL -UseBasicParsing).Links | Where-Object { ($_.outerHTML -like "*DellTPM2.0*") -and ($_.outerHTML -like "*WINDOWS*") -and ($_.outerHTML -like "*64*")} | select -First 1
		$BIOSFile = $BIOSDownload.href | Split-Path -Leaf
			
		$WebClient = New-Object System.Net.WebClient
        $URL = $DellDownloadBase + $BIOSDownload.href
        $file = "$PSScriptRoot\$BIOSFile"
        $WebClient.DownloadFile($url,$file)

<#Added TS Variables for if using during OSD.  Creates Variable SMSTS_BiosUpdate, and sets to TRUE. (For Future Use)
	http://powershelldistrict.com/how-to-read-and-write-sccm-task-sequence-variables-with-powershell/

#>
$tsenv = New-Object -COMObject Microsoft.SMS.TSEnvironment -ErrorAction SilentlyContinue
$tsenv.Value("SMSTS_BiosUpdate") = "True"

#Create Log Path
$LogPath = $tsenv.Value("_SMSTSLogPath")

#Get Bios File Name (No Extension, used to create Log File)
$BiosLogFileName = $BiosFile.Replace(".exe",".log")

# Validate BIOS Update File Successful Download
If(!(Test-Path $file)){
    Add-Content -Path "$LogPath\BIOSUpdate_$ComputerModel.log" -Value "BIOS update file did not download correctly"
    $tsenv.Value("SMSTS_BiosUpdateFailedDownload") = "True"
    Exit
}

#Set Command Arguments for Bios Update
$cmds = "/s /p=$BiosPassword /l=$LogPath\$BiosLogFileName"

#Update Bios
$Process = start-process $File -ArgumentList $cmds -PassThru -wait


#Creates and Set TS Variable to be used to run additional steps if reboot requried.
if ($process.ExitCode -eq 2)
    {$tsenv.Value("SMSTS_BiosUpdateRebootRequired") = "True"}
    else
    {$tsenv.Value("SMSTS_BiosUpdateRebootRequired") = "False"}
	